<template>
  <PageWrapper dense fixedHeight contentFullHeight contentClass="flex">
    <BasicTable
      @register="registerTable"
      :row-selection="{ selectedRowKeys: selectedKeys, onChange: onSelectChange }"
    >
      <template #toolbar>
        <template v-for="button in tableButtonConfig" :key="button.code">
          <a-button v-if="button.isDefault" type="primary" @click="buttonClick(button.code)">
            <template #icon><Icon :icon="button.icon" /></template>
            {{ button.name }}
          </a-button>
          <a-button v-else type="primary">
            <template #icon><Icon :icon="button.icon" /></template>
            {{ button.name }}
          </a-button>
        </template>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.dataIndex === 'action'">
          <TableAction :actions="getActions(record)" />
        </template>
        <template v-if="column.dataIndex == 'products'">
          <a-dropdown v-if="record.products">
            <span>
              {{ record.products.split(',')[0]?.split(':')[0] }}
              <DownOutlined />
            </span>
            <template #overlay>
              <a-menu>
                <a-menu-item v-for="(item, index) in record.products.split(',')" :key="index">
                  <a href="javascript:;">{{ item }}</a>
                </a-menu-item>
              </a-menu>
            </template>
          </a-dropdown>
        </template>
      </template>
    </BasicTable>

    <PrintPreview
      v-if="printData.visible"
      :id="printData.id"
      :request-params-configs="printData.requestParamsConfigs"
      :request-body-configs="printData.requestBodyConfigs"
      :request-header-configs="printData.requestHeaderConfigs"
      @close="printData.visible = false"
    />
    <!-- <WarehouseChgModal @register="registerModal" @success="handleSuccess" /> -->
    <a-modal
      :maskClosable="false"
      :title="titleModa"
      v-model:visible="visibleModa"
      :confirm-loading="confirmLoading"
      width="80%"
      :footer="null"
    >
      <WarehouseChgModal
        :rowData="rowData"
        @cancel="visibleModa = false"
        @success="handleSuccess"
      ></WarehouseChgModal>
    </a-modal>
  </PageWrapper>
</template>
<script lang="ts" setup>
  import { ref, computed, createVNode, reactive } from 'vue';
  import { DownOutlined, UpOutlined } from '@ant-design/icons-vue';
  import { Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import { BasicTable, useTable, TableAction, ActionItem } from '/@/components/Table';
  import {
    getMesWarehouseChgPage,
    deleteMesWarehouseChg,
    exportMesWarehouseChg,
    finishMesWarehouseChg,
  } from '/@/api/mes/warehousechg';
  import { PageWrapper } from '/@/components/Page';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { usePermission } from '/@/hooks/web/usePermission';
  import { useRouter } from 'vue-router';

  import { getPrintConfigInfo } from '/@/api/system/generator/print';
  import PrintPreview from '/@/views/generator/print/Preview.vue';
  import { getMesWarehouseChg } from '/@/api/mes/warehousechg';
  import { PrintButton } from '/@/enums/printEnum';
  import { InputParamItem } from '/@/components/ApiConfig/src/interface';

  import { useModal } from '/@/components/Modal';

  import WarehouseChgModal from './components/WarehouseChgModal.vue';

  import { downloadByData } from '/@/utils/file/download';

  import { searchFormSchema, columns } from './components/config';
  import Icon from '/@/components/Icon/index';

  const { notification } = useMessage();
  const { t } = useI18n();
  defineEmits(['register']);
  const { filterColumnAuth, filterButtonAuth } = usePermission();

  const filterColumns = filterColumnAuth(columns, false);
  //展示在列表内的按钮
  const actionButtons = ref<string[]>(['view', 'edit', 'delete', 'startwork', 'finish']);
  const buttonConfigs = computed(() => {
    const list = [
      { isUse: true, code: 'view', icon: 'ant-design:eye-outlined', isDefault: true, name: '查看' },
      { isUse: true, code: 'add', icon: 'ant-design:plus-outlined', isDefault: true, name: '新增' },
      {
        isUse: true,
        code: 'edit',
        icon: 'ant-design:form-outlined',
        isDefault: true,
        name: '编辑',
      },
      {
        isUse: true,
        code: 'delete',
        icon: 'ant-design:delete-outlined',
        isDefault: true,
        name: '删除',
      },
      {
        isUse: true,
        code: 'export',
        icon: 'ant-design:export-outlined',
        isDefault: true,
        name: '导出',
      },
      {
        isUse: true,
        name: '确认',
        code: 'finish',
        icon: 'ant-design:check-outlined',
        isDefault: true,
      },
    ];
    return filterButtonAuth(list);
  });

  const tableButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => !actionButtons.value.includes(x.code));
  });

  const actionButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => actionButtons.value.includes(x.code));
  });

  const btnEvent = {
    view: handleView,
    add: handleAdd,
    edit: handleEdit,
    delete: handleDelete,
    export: handleExport,
    finish: handleFinish,
  };

  const { currentRoute } = useRouter();
  const printMenuId = computed(() => currentRoute.value.meta.menuId as string);
  const formIdComputedRef = computed(() => currentRoute.value.meta.formId as string);

  const selectedKeys = ref<string[]>([]);
  const selectedRowsData = ref<any[]>([]);

  const [registerModal, { openModal }] = useModal();

  // 模板打印 入参参数
  let printData: {
    visible: boolean;
    id: string;
    code: string;
    requestParamsConfigs: Array<InputParamItem>;
    requestHeaderConfigs: Array<InputParamItem>;
    requestBodyConfigs: Array<InputParamItem>;
  } = reactive({
    visible: false,
    id: '',
    code: '',
    requestParamsConfigs: [],
    requestHeaderConfigs: [],
    requestBodyConfigs: [],
  });

  const [registerTable, { reload }] = useTable({
    title: '调拨列表',
    api: getMesWarehouseChgPage,
    rowKey: 'id',
    columns: filterColumns,
    formConfig: {
      rowProps: {
        gutter: 16,
      },
      schemas: searchFormSchema,
      fieldMapToTime: [['dataDate', ['dataDateStart', 'dataDateEnd'], 'YYYY-MM-DD ', true]],
    },
    beforeFetch: (params) => {
      return { ...params, FormId: formIdComputedRef.value, PK: 'id' };
    },
    useSearchForm: true,
    showTableSetting: false,
    showLine: true,
    striped: false,
    actionColumn: {
      align: 'left',
      width: 200,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
    },
    customRow,
  });

  function buttonClick(code) {
    if (code.includes(PrintButton.CODE)) {
      printData.code = code;
    }
    btnEvent[code]();
  }
  function handleFinish(record: Recordable) {
    Modal.confirm({
      title: '提示信息',
      icon: createVNode(ExclamationCircleOutlined),
      content: '是否确认提交？提交后库存生效',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        finishMesWarehouseChg(record.id).then((_) => {
          reload();
          notification.success({
            message: 'Tip',
            description: t('调拨成功！'),
          });
        });
      },
      onCancel() {},
    });
  }
  const titleModa = ref<string>('');
  const visibleModa = ref<boolean>(false);
  const confirmLoading = ref<boolean>(false);
  const rowData = ref({});
  function handleAdd() {
    rowData.value = {
      id: '',
      isUpdate: true,
    };
    titleModa.value = '新增调拨';
    visibleModa.value = true;
  }

  function handleEdit(record: Recordable) {
    rowData.value = {
      id: record.id,
      isUpdate: true,
    };
    titleModa.value = '编辑调拨';
    visibleModa.value = true;
  }

  function handleDelete(record: Recordable) {
    deleteList([record.id]);
  }

  function deleteList(ids) {
    Modal.confirm({
      title: '提示信息',
      icon: createVNode(ExclamationCircleOutlined),
      content: '是否确认删除？',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        deleteMesWarehouseChg(ids).then((_) => {
          reload();
          notification.success({
            message: 'Tip',
            description: t('删除成功！'),
          });
        });
      },
      onCancel() {},
    });
  }

  // 模板打印
  async function handleTemplateprint() {
    if (!selectedKeys.value.length) {
      notification.warning({
        message: t('提示'),
        description: t('请选择数据'),
      });
      return;
    }
    if (selectedKeys.value.length > 1) {
      notification.warning({
        message: t('提示'),
        description: t('只能选择一条数据进行操作'),
      });
      return;
    }
    let id = selectedKeys.value[0];
    try {
      const record = await getMesWarehouseChg(id);
      let res = await getPrintConfigInfo(printData.code, printMenuId.value);
      if (res.enabledMark == null) {
        notification.warning({
          message: t('提示'),
          description: t('当前功能未绑定打印模板，请绑定后再进行模板打印。'),
        });
        return;
      }
      if (res.enabledMark == 0) {
        notification.warning({
          message: t('提示'),
          description: t('找不到打印模板，请联系管理员。'),
        });
        return;
      }
      printData.id = res.schemaId;
      if (res.apiConfig) {
        let json = JSON.parse(res.apiConfig);
        if (json.requestParamsConfigs && json.requestParamsConfigs.length > 0) {
          printData.requestParamsConfigs = json.requestParamsConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        if (json.requestHeaderConfigs && json.requestHeaderConfigs.length > 0) {
          printData.requestHeaderConfigs = json.requestHeaderConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        if (json.requestBodyConfigs && json.requestBodyConfigs.length > 0) {
          printData.requestBodyConfigs = json.requestBodyConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        printData.visible = true;
      } else {
        notification.warning({
          message: t('提示'),
          description: t('当前功能未绑定打印模板，请绑定后再进行模板打印。'),
        });
      }
    } catch (error) {}
  }

  function onSelectChange(selectedRowKeys: [], selectedRows) {
    selectedKeys.value = selectedRowKeys;
    selectedRowsData.value = selectedRows;
  }

  function customRow(record: Recordable) {
    return {
      onClick: () => {
        let selectedRowKeys = [...selectedKeys.value];
        if (selectedRowKeys.indexOf(record.id) >= 0) {
          let index = selectedRowKeys.indexOf(record.id);
          selectedRowKeys.splice(index, 1);
        } else {
          selectedRowKeys.push(record.id);
        }
        selectedKeys.value = selectedRowKeys;
      },
    };
  }

  function handleSuccess() {
    visibleModa.value = false;
    reload();
  }

  function handleView(record: Recordable) {
    rowData.value = {
      id: record.id,
      isUpdate: false,
    };
    titleModa.value = '查看调拨';
    visibleModa.value = true;
  }

  async function handleExport() {
    const res = await exportMesWarehouseChg({ isTemplate: false });
    downloadByData(
      res.data,
      '调拨列表.xlsx',
      'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
    );
  }

  function getActions(record: Recordable): ActionItem[] {
    const actionsList: ActionItem[] = actionButtonConfig.value?.map((button) => {
      if (!record.workflowData?.processId) {
        return {
          icon: button?.icon,
          tooltip: button?.name,
          color: button.code === 'delete' ? 'error' : undefined,
          onClick: btnEvent[button.code].bind(null, record),
        };
      } else {
        if (button.code === 'view') {
          return {
            icon: button?.icon,
            tooltip: button?.name,
            onClick: btnEvent[button.code].bind(null, record),
          };
        } else {
          return {};
        }
      }
    });
    return actionsList.filter((e) => {
      if (e.tooltip == '编辑' || e.tooltip == '删除' || e.tooltip == '确认') {
        if (!record.state || record.state == '待确认' || record.state == '0') return true;
        else return false;
      } else return true;
    });
  }
</script>
<style lang="less" scoped>
  :deep(.ant-table-selection-col) {
    width: 50px;
  }
</style>
